#TEMPLATE (DP_CLASS, 'DP CLASS DEFINITIONS'), FAMILY('ABC'), FAMILY('CW20')
#PROCEDURE (DP_Class_Source, 'DP Class Source Procedure')
#PROMPT ('Declaration file:', @s180), %dpxfile1
#PROMPT ('Definition file:', @s180), %dpxfile2
#PROMPT ('Interface file:', @s180), %dpxfile3
#prompt ('Export classes?', check), %createexport
#PROMPT('Generate !ABCIncludeFile',CHECK),%abcinclude,default(0)
#!PROMPT ('Include MEMBER(appname)?', check), %includemember
#atstart
#endat

#if(not %editprocedure)
#CREATE ('dptmp.$$2')
#endif
#!=================================================================================
#!=================================================================================
#!=================================================================================

#if(%dpxfile3)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Interface File Contents
!!!!! File Name: %dpxfile3
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#EMBED (%InterfaceFile, 'Interface File '), DATA      #! Embedded Source Code

#endif
#if(not %editprocedure)
#CLOSE
#IF(%dpxfile3)
#REPLACE (%dpxfile3, 'dptmp.$$2')
#REMOVE ('dptmp.$$2')
#endif
#CREATE ('dptmp.$$2')
#endif
#!=================================================================================
#!=================================================================================
#!=================================================================================
#if(%dpxfile1)
   #IF(%abcinclude)
!ABCIncludeFile
   #ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: %dpxfile1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#EMBED (%ClassDeclaration, 'Class Declarations'), DATA       #! Embedded Source Code

#endif

#if(not %editprocedure)
#CLOSE
#if(%dpxfile1)
#REPLACE (%dpxfile1, 'dptmp.$$2')
#REMOVE ('dptmp.$$2')
#endif
#CREATE ('dptmp.$$2')
#!if (%includemember)
#!   member('%application')
#!endif
#endif
#!=================================================================================
#!=================================================================================
#!=================================================================================
#if(%dpxfile2)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: %dpxfile2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#EMBED (%ClassDefinition, 'Class Definitions'), DATA  #! Embedded Source Code

#endif

#if(not %editprocedure)
#CLOSE
#if(%dpxfile2)
#REPLACE (%dpxfile2, 'dptmp.$$2')
#endif
#endif

%Procedure procedure  ! dummy procedure for template
  code
#at(%DLLEXPORTLIST)
#if(%createexport)
#insert(%doClassExports,%dpxfile1)
#ENDIF
#ENDAT
#!
#!
#!
#!
#UTILITY(ExportInc,'Create INC of Export Procedures')
#DECLARE(%Procout)
#CREATE(%Application & '.INC')
#FOR(%Procedure)
    #IF(%ProcedureExported)
        #SET(%Procout,%Procedure)
        #IF(%Prototype)
            #SET(%Procout,%Procout & %Prototype)
        #ELSE
            #SET(%Procout,%Procout & '()')
        #ENDIF
        #IF(%ProcedureDescription)
    %[50]Procout !%ProcedureDescription)
        #ELSE
    %Procout
        #ENDIF
    #ENDIF
#ENDFOR
#CLOSE
#!
#!
#!
#!
#PROCEDURE(twCloneProcedure, 'twClone Procedure')
%procedure procedure
#embed(%ProcedureDataSection, 'Local procedure data')

#insert(%twCloneDataGroup)

#insert(%twCloneCodeGroup)


#EXTENSION(twClone, 'twClone')
#at(%datasection)
#insert(%twClonedataGroup)
#endat

#at(%processedCode)
#insert(%twclonecodegroup)
#endat

#group(%twClonedataGroup)

localclass  class(twcloneClassType), type
CloneControls   procedure(*window pwindow, long pgroup), derived
Call            procedure(string pcmd, <string p1>, <string p2>, <string p3>), string, proc, derived
Notify          procedure(string pcmd, <string p1>, <string p2>, <string p3>), string, proc, derived
Refresh         procedure(), derived
TakeEvent       procedure(), byte, proc, derived
Construct       procedure
destruct        procedure
#embed(%LocalClassMethods, 'Local Class Methods and Properties')
            end

lc  &localclass

#group(%twclonecodegroup)
  lc &= new LocalClass
  return lc.twclone

localclass.construct  procedure
#embed(%ConstructorData, 'Constructor Data')
  code
#embed(%Constructorcode, 'Constructor Code')

localclass.destruct procedure
#embed(%DestructorData, 'Destructor Data')
  code
#embed(%DestructorCode, 'Destructor Code')


localclass.clonecontrols  procedure(*window pwindow, long pgroup)
  code
  open(window)
  self.clonecontrols(window, pwindow, pgroup)
  close(window)
#embed(%CloneControlsCode, 'Clone Controls Code')

localclass.Refresh procedure
#embed(%RefreshMethodData, 'Refresh Method Data')
  code
#embed(%RefreshMethodCode, 'Refresh Method Code')


LocalClass.Call            procedure(string pcmd, <string p1>, <string p2>, <string p3>)!, string, proc, derived
#embed(%CallMethodData, 'Call Method Data')
  code
#embed(%CallMethodCode, 'Call Method Code')
  return parent.call(pcmd, p1, p2, p3)

LocalClass.Notify          procedure(string pcmd, <string p1>, <string p2>, <string p3>)!, string, proc, derived
#embed(%NotifyMethodData, 'Notify Method Data')
  code
#embed(%NotifyMethodCode, 'Notify Method Code')
  return parent.Notify(pcmd, p1, p2, p3)

LocalClass.TakeEvent      procedure()
#embed(%TakeEventMethodData, 'TakeEvent Method Data')
  code
#embed(%TakeEventMethodCode, 'TakeEvent Method Code')
  return parent.TakeEvent()





#EXTENSION(dp_classes_to_export_ABC, 'Custom Classes to Export File ABC')
#prompt('Declarion (*.inc) file', @s200), %xxfile
#at(%DLLEXPORTLIST)
#insert(%doClassExports,%xxfile)
#endat
#!
#!
#group(%doclassexports, %filename22), auto
#DECLARE(%FILETXT)
#DECLARE(%LASTCLASS)
#DECLARE(%PROCNAME)
#DECLARE(%TEMPLINE)
#open(%filename22),READ
#LOOP
  #READ(%FILETXT)
  #IF(%FILETXT = %EOF)
    #BREAK
  #ENDIF
  #IF (SUB(LEFT(%FILETXT), 1, 1)='!')
    #CYCLE
  #ENDIF
  #SET(%FILETXT, UPPER(%FILETXT))
  #IF (INSTRING('!', %FILETXT,1,1))
    #set(%templine, sub(%filetxt, 1, instring('!', %filetxt,1,1)))
  #ELSE
    #SET(%TEMPLINE, %FILETXT)
  #ENDIF
  #if(instring(' CLASS', %templine, 1, 1))
    #set(%VALUECONSTRUCT,SUB(%FILETXT, 1, INSTRING(' ', %FILETXT,1,1)))
#!; class exported:  %valueconstruct
    TYPE$%VALUECONSTRUCT @?
    VMT$%VALUECONSTRUCT  @?
    #set(%lastclass, %valueconstruct)
  #ENDIF
  #IF(INSTRING(' PROCEDURE(', %TEMPLINE, 1, 1))
    #set(%PROCNAME, sub(%filetxt, 1, instring(' PROCEDURE(', %filetxt, 1, 1)-1))
    #set(%valueconstruct, sub(%filetxt, instring(' PROCEDURE(', %FILETXT, 1, 1)+11, 200))
    #set(%valueconstruct, %procname & '(' & %lastclass & ',' & %valueconstruct)
#!      ; method exported: %valueconstruct
               %(LINKNAME(UPPER(%VALUECONSTRUCT))) @?
  #ELSIF (INSTRING(' PROCEDURE', %TEMPLINE, 1, 1))
    #set(%PROCNAME, sub(%filetxt, 1, instring(' PROCEDURE', %filetxt, 1, 1)-1))
    #set(%valueconstruct, sub(%filetxt, instring(' PROCEDURE', %FILETXT, 1, 1), 200))
    #SET(%VALUECONSTRUCT, %PROCNAME & '(' & %LASTCLASS & ')')
#!      ; method exported: %valueconstruct
               %(LINKNAME(UPPER(%VALUECONSTRUCT))) @?
  #ENDIF
#ENDLOOP
#CLOSE(%filename22),READ
